Index: src/backend/commands/copy.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/copy.c,v
retrieving revision 1.257
diff -c -r1.257 copy.c
*** src/backend/commands/copy.c	28 Dec 2005 03:25:32 -0000	1.257
--- src/backend/commands/copy.c	30 Jan 2006 00:39:28 -0000
***************
*** 51,56 ****
--- 51,57 ----
  
  #define ISOCTAL(c) (((c) >= '0') && ((c) <= '7'))
  #define OCTVALUE(c) ((c) - '0')
+ #define BADCHARS "\r\n\\"
  
  /*
   * Represents the different source/dest cases we need to worry about at
***************
*** 856,861 ****
--- 857,867 ----
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("COPY delimiter must be a single character")));
  
+ 	/* Disallow the forbidden_delimiter strings from src/include/commands/copy.h */
+ 	if (strcspn(cstate->delim, BADCHARS) != 1)
+ 		elog(ERROR, "COPY delimiter cannot be %#02x",
+ 			 *cstate->delim);
+ 
  	/* Check header */
  	if (!cstate->csv_mode && cstate->header_line)
  		ereport(ERROR,
